#include <iostream>

using namespace std;
int niz[1000000];
int krajnji[1000000];
int q;
int main()
{
    int n , k;
    cin>>n;
    cin>>k;
    for(int i = 0;i<n;i++)
    {
        int poz;
        cin>>poz;
        if(niz[poz+n]==-1)
            continue;
        else if((niz[poz+n]+1)==k)
        {
            krajnji[q]=poz;
            q++;
            niz[poz+n]=-1;
        }
        else
        {
            niz[poz+n]++;
        }
    }
    cout<<q--<<endl;
    for(int j= 0;j<=q;j++)
        cout<<krajnji[j]<<" ";
    return 0;
}